/***************************************************************************
                          panelswindow.h  -  description
                             -------------------
    begin                : Mon Aug 6 2001
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PANELSWINDOW_H
#define PANELSWINDOW_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qlabel.h>

#include "general.h"
#include "ksensorsmain.h"
#include "sensordevslist.h"
#include "sensorpanel.h"
#include "syssensorslist.h"
#include "ksensorssetting.h"


class KsensorsMain;

/**
  *@original author Miguel Novas
  */

class PanelsWindow : public QWidget, public ksensorsSetting
{
   Q_OBJECT
public:  
    PanelsWindow ( KsensorsMain *ksensorsMainIn, MeterTypes meterTypeIns, QWidget *parent = nullptr, const QString &name = QString() );
    ~PanelsWindow();

    void updateWidget( const QString &name, bool withChange );
    void updateValue( const QString & name );
        
    void saveGeometry();

    void setMeterTypes( MeterTypes meterTypesIn ) { meterTypes = meterTypesIn; };
    MeterTypes getMeterTypes() { return ( meterTypes ); };


/* public:
  QTimer qtResize;
  
public Q_SLOTS:    
  void resizeDone();
    
protected:
  bool event(QEvent *event) override; */
  
  
protected Q_SLOTS:

Q_SIGNALS:

   void rightMouseClicked(QMouseEvent *);

private:
    KsensorsMain *ksensorsMain;

    MeterTypes meterTypes;

    QLabel *qlMess;

    int meterWidth;
    int meterHeight;

  QWidget    *childDraging;  
  QPoint			origMousePt;

  bool windowsSolid;
  QPixmap qpmBackGround;
  QPalette qpPanelWindow;

  void updatePanels( bool enabForce );
  void updateMessLabel( bool enabView );

  void loadPalette(Panel *panel = nullptr);
//  void setBackgroundPixmap ( const QPixmap &qpmBackGround );
  void loadDisplayConfig(Panel *display);
  void saveDisplayConfig(Panel *display);
  void mouseReleaseEvent ( QMouseEvent *m ) override;
  void mouseMoveEvent ( QMouseEvent *m ) override;

  void createSensorPanels();
  void findUnusedPosition( Panel *displayIn, int *px,int *py );
  void startDragChild(QMouseEvent *m, QWidget *w);
  void endDragChild();
  void loadGeneralOptions( bool enabForce );

private Q_SLOTS:

  void childEvent(QChildEvent *) override;
  void childEventReceived(QEvent *);

};

#endif
