/***************************************************************************
                          sensorscfg.h  -  description
                             -------------------
    begin                : Mon Aug 13 2001
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SENSORSCFG_H
#define SENSORSCFG_H

//#include <qobject.h>

#include <kpagedialog.h>

#include "ksensorsmain.h"
#include "ksensorssetting.h"
#include "sensordev.h"
#include "sensorscfgdesign.h"
#include "palettecfg.h"

/**
  *@author 
  */

class sensorsCfg : public sensorsCfgDesign, public ksensorsSetting
{
Q_OBJECT
public:
	sensorsCfg( KPageDialog *kpdKSensorsCfgIn, KsensorsMain *ksensorsMainIn, SensorDev *sensorsListIn, const QString &name = QString() );
	~sensorsCfg();

protected Q_SLOTS:

  void slotAccept();

  void slotTestAlarm();
  void slotCurrentSensorChanged(int index);

  void slotMainTabPageChanged(int index);
  void slotComboMinMaxSelected(int index);

public Q_SLOTS:
  void slotApplyChanges();

protected:

  void applySensorChanges();
  void applyPreferencesChanges();
  void applySensorAlarmConfig(Sensor *sensor);

  void readSensorInfo(int currentRow);
  void readPreferencesInfo();
  void readSensorsList();
  
protected:
  virtual void showEvent ( QShowEvent *event ) override;

private:

  PaletteCfg *palPanelCfg;

    bool disabSetHeader;

    KPageDialog *kpdKSensorsCfg;
    KsensorsMain *ksensorsMain;
    SensorDev *sensorsList;

  Sensor      *curSensor;
};

#endif
