/***************************************************************************
    file:           syssensorslist.h
    description:    system sensors list
    begin:          09/06/2024
    Copyright:      Giuseppe Della Bianca<giusdbg@gmail.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SYSSENSORSLIST_H
#define SYSSENSORSLIST_H

#include <sensordev.h>

class SYSSensorsList : public SensorDev
{
Q_OBJECT
public:

  SYSSensorsList( SensorDevsList *sensorDevsList, const QString &name );
  ~SYSSensorsList();

public Q_SLOTS:

  void updateSensors ( bool enabUpdate ) override;

private:

  Sensor *sCpuInfo;
  Sensor *sCpuLoad;
  Sensor *sRamUsed;
  Sensor *sSwapUsed;
  Sensor *sUpTime;

  int old_user,old_nice,old_system,old_idle;
  
};

#endif
